/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_IDENTIFIER = 258,
     TOK_TYPE = 259,
     TOK_NUMBER = 260,
     TOK_STRING = 261,
     TOK_CONST = 262,
     TOK_INCR = 263,
     TOK_DECR = 264,
     TOK_IF = 265,
     TOK_ELSE = 266,
     TOK_BOGUS = 267,
     TOK_ADDEQ = 268,
     TOK_SUBEQ = 269,
     TOK_MULEQ = 270,
     TOK_DIVEQ = 271,
     TOK_MODEQ = 272,
     TOK_ANDEQ = 273,
     TOK_XOREQ = 274,
     TOK_OREQ = 275,
     TOK_LSFTEQ = 276,
     TOK_RSFTEQ = 277,
     TOK_OROR = 278,
     TOK_ANDAND = 279,
     TOK_EQEQ = 280,
     TOK_NEQ = 281,
     TOK_LTEQ = 282,
     TOK_GTEQ = 283,
     TOK_LTLT = 284,
     TOK_GTGT = 285,
     TOK_RETURN = 286,
     TOK_DO = 287,
     TOK_WHILE = 288,
     TOK_FOR = 289,
     TOK_EXTERN = 290,
     TOK_BREAK = 291,
     TOK_CONTINUE = 292,
     TOK_STRUCT = 293,
     TOK_KEY_STRING = 294,
     TOK_EXPORT = 295,
     TOK_LINK = 296,
     TOK_EVEN = 297,
     TOK_ARROW = 298,
     PREFIX = 299,
     SUFFIX = 300,
     INEQUALITIES = 301
   };
#endif
#define TOK_IDENTIFIER 258
#define TOK_TYPE 259
#define TOK_NUMBER 260
#define TOK_STRING 261
#define TOK_CONST 262
#define TOK_INCR 263
#define TOK_DECR 264
#define TOK_IF 265
#define TOK_ELSE 266
#define TOK_BOGUS 267
#define TOK_ADDEQ 268
#define TOK_SUBEQ 269
#define TOK_MULEQ 270
#define TOK_DIVEQ 271
#define TOK_MODEQ 272
#define TOK_ANDEQ 273
#define TOK_XOREQ 274
#define TOK_OREQ 275
#define TOK_LSFTEQ 276
#define TOK_RSFTEQ 277
#define TOK_OROR 278
#define TOK_ANDAND 279
#define TOK_EQEQ 280
#define TOK_NEQ 281
#define TOK_LTEQ 282
#define TOK_GTEQ 283
#define TOK_LTLT 284
#define TOK_GTGT 285
#define TOK_RETURN 286
#define TOK_DO 287
#define TOK_WHILE 288
#define TOK_FOR 289
#define TOK_EXTERN 290
#define TOK_BREAK 291
#define TOK_CONTINUE 292
#define TOK_STRUCT 293
#define TOK_KEY_STRING 294
#define TOK_EXPORT 295
#define TOK_LINK 296
#define TOK_EVEN 297
#define TOK_ARROW 298
#define PREFIX 299
#define SUFFIX 300
#define INEQUALITIES 301




/* Copy the first part of user declarations.  */
#line 1 "src/compile.y"

#include <stdio.h>
#include <string.h>
#include "compile.h"
#include "namespace.h"
#include "hir.h"
#include "lir.h"
#include "type.h"
 
void yyerror(const char *str)
{
	fprintf(stderr,"%s:%i: %s\n", input_filename, yylineno, str);
	errors++;
}
 
int yywrap()
{
	return 1;
} 
  


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 23 "src/compile.y"
typedef union YYSTYPE {
	long numeric;
	char *string;
	id_handle_t identifier;
	type_handle_t datatype;
	hir_interm_t subexpr;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 197 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 209 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   493

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  70
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  62
/* YYNRULES -- Number of rules. */
#define YYNRULES  151
/* YYNRULES -- Number of states. */
#define YYNSTATES  285

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   301

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    44,     2,     2,     2,    50,    56,     2,
      64,    65,    48,    51,    66,    52,    69,    49,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    63,    60,
      53,    59,    54,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    67,     2,    68,    57,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    61,    58,    62,    45,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    46,
      47,    55
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    13,    15,    17,
      20,    23,    29,    30,    35,    39,    43,    48,    50,    53,
      55,    58,    63,    68,    73,    78,    82,    89,    98,   101,
     102,   104,   108,   109,   111,   115,   118,   122,   125,   128,
     134,   139,   142,   146,   148,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   172,   174,   178,   180,   184,
     188,   192,   196,   200,   204,   208,   212,   216,   220,   224,
     226,   230,   232,   236,   238,   242,   244,   248,   250,   254,
     256,   260,   264,   266,   270,   274,   278,   282,   284,   288,
     292,   294,   298,   302,   304,   308,   312,   316,   318,   321,
     324,   327,   330,   333,   336,   339,   342,   344,   346,   349,
     352,   357,   361,   365,   367,   369,   373,   375,   376,   382,
     383,   385,   389,   391,   393,   395,   396,   403,   404,   409,
     413,   414,   423,   424,   431,   432,   443,   444,   446,   449,
     455,   458,   464,   465,   473,   475,   478,   479,   485,   486,
     490,   497
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      71,     0,    -1,    -1,    71,    72,    -1,    73,    -1,   126,
      -1,    79,    -1,    80,    -1,    81,    -1,    74,    60,    -1,
      74,    76,    -1,    35,    74,    59,     5,    60,    -1,    -1,
      77,     3,    75,    83,    -1,    61,    86,    62,    -1,    61,
      89,    62,    -1,    61,    86,    89,    62,    -1,    78,    -1,
      77,    48,    -1,     4,    -1,    38,     3,    -1,     4,    63,
      92,    60,    -1,    39,    63,     6,    60,    -1,    41,    63,
       3,    60,    -1,    41,    63,     5,    60,    -1,    40,     3,
      60,    -1,    40,     3,    64,    93,    65,    60,    -1,    40,
       3,    64,    93,    66,    93,    65,    60,    -1,    42,    60,
      -1,    -1,     3,    -1,    64,    84,    65,    -1,    -1,    85,
      -1,    84,    66,    85,    -1,    77,    82,    -1,    86,    87,
      60,    -1,    87,    60,    -1,    77,     3,    -1,    77,     3,
      67,    92,    68,    -1,    77,     3,    59,    93,    -1,    61,
      62,    -1,    61,    89,    62,    -1,    90,    -1,    89,    90,
      -1,    90,    -1,    91,    -1,   111,    -1,   117,    -1,   119,
      -1,   121,    -1,   116,    -1,   124,    -1,   125,    -1,    92,
      60,    -1,    93,    -1,    92,    66,    93,    -1,    94,    -1,
      93,    59,    93,    -1,    93,    13,    93,    -1,    93,    14,
      93,    -1,    93,    15,    93,    -1,    93,    16,    93,    -1,
      93,    17,    93,    -1,    93,    18,    93,    -1,    93,    19,
      93,    -1,    93,    20,    93,    -1,    93,    21,    93,    -1,
      93,    22,    93,    -1,    95,    -1,    94,    23,    94,    -1,
      96,    -1,    95,    24,    95,    -1,    97,    -1,    96,    58,
      96,    -1,    98,    -1,    97,    57,    97,    -1,    99,    -1,
      98,    56,    98,    -1,   100,    -1,    99,    25,    99,    -1,
      99,    26,    99,    -1,   101,    -1,   100,    53,   100,    -1,
     100,    27,   100,    -1,   100,    54,   100,    -1,   100,    28,
     100,    -1,   102,    -1,   101,    29,   101,    -1,   101,    30,
     101,    -1,   103,    -1,   102,    51,   102,    -1,   102,    52,
     102,    -1,   104,    -1,   103,    48,   103,    -1,   103,    49,
     103,    -1,   103,    50,   103,    -1,   105,    -1,    44,   104,
      -1,    45,   104,    -1,     8,   104,    -1,     9,   104,    -1,
      51,   104,    -1,    52,   104,    -1,    48,   104,    -1,    56,
     104,    -1,   106,    -1,   107,    -1,   105,     8,    -1,   105,
       9,    -1,   105,    67,    92,    68,    -1,   105,    69,     3,
      -1,   105,    43,     3,    -1,     3,    -1,     5,    -1,    64,
      92,    65,    -1,     6,    -1,    -1,     3,   108,    64,   109,
      65,    -1,    -1,   110,    -1,   109,    66,   110,    -1,    93,
      -1,   112,    -1,   114,    -1,    -1,    10,    64,    93,    65,
     113,    88,    -1,    -1,   112,    11,   115,    88,    -1,    31,
      92,    60,    -1,    -1,    32,   118,    88,    33,    64,    92,
      65,    60,    -1,    -1,    33,    64,    92,    65,   120,    88,
      -1,    -1,    34,    64,   123,    60,   123,    60,   123,    65,
     122,    88,    -1,    -1,    92,    -1,    36,    60,    -1,    36,
      64,     5,    65,    60,    -1,    37,    60,    -1,    37,    64,
       5,    65,    60,    -1,    -1,    38,     3,   127,    61,   128,
      62,    60,    -1,   129,    -1,   128,   129,    -1,    -1,    77,
       3,   130,   131,    60,    -1,    -1,    67,    92,    68,    -1,
      67,    92,    68,    67,    92,    68,    -1,    67,    92,    68,
      67,    92,    68,    67,    92,    68,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    55,    55,    57,    61,    62,    63,    64,    65,    71,
      73,    75,    81,    80,    86,    87,    88,    93,    94,    99,
     101,   106,   108,   110,   112,   119,   121,   123,   128,   134,
     135,   142,   145,   147,   148,   152,   158,   159,   163,   165,
     183,   199,   200,   201,   205,   206,   210,   211,   212,   213,
     214,   215,   216,   217,   221,   226,   227,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   246,
     247,   251,   252,   256,   257,   261,   262,   266,   267,   271,
     272,   273,   277,   278,   279,   280,   281,   285,   286,   287,
     291,   292,   293,   297,   298,   299,   300,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   316,   317,   318,   319,
     320,   321,   322,   326,   327,   328,   329,   335,   334,   340,
     342,   343,   347,   354,   356,   362,   361,   369,   368,   375,
     383,   382,   390,   389,   397,   396,   402,   404,   408,   410,
     415,   417,   425,   424,   431,   432,   437,   436,   442,   444,
     446,   449
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_IDENTIFIER", "TOK_TYPE", "TOK_NUMBER", 
  "TOK_STRING", "TOK_CONST", "TOK_INCR", "TOK_DECR", "TOK_IF", "TOK_ELSE", 
  "TOK_BOGUS", "TOK_ADDEQ", "TOK_SUBEQ", "TOK_MULEQ", "TOK_DIVEQ", 
  "TOK_MODEQ", "TOK_ANDEQ", "TOK_XOREQ", "TOK_OREQ", "TOK_LSFTEQ", 
  "TOK_RSFTEQ", "TOK_OROR", "TOK_ANDAND", "TOK_EQEQ", "TOK_NEQ", 
  "TOK_LTEQ", "TOK_GTEQ", "TOK_LTLT", "TOK_GTGT", "TOK_RETURN", "TOK_DO", 
  "TOK_WHILE", "TOK_FOR", "TOK_EXTERN", "TOK_BREAK", "TOK_CONTINUE", 
  "TOK_STRUCT", "TOK_KEY_STRING", "TOK_EXPORT", "TOK_LINK", "TOK_EVEN", 
  "TOK_ARROW", "'!'", "'~'", "PREFIX", "SUFFIX", "'*'", "'/'", "'%'", 
  "'+'", "'-'", "'<'", "'>'", "INEQUALITIES", "'&'", "'^'", "'|'", "'='", 
  "';'", "'{'", "'}'", "':'", "'('", "')'", "','", "'['", "']'", "'.'", 
  "$accept", "start", "glbl", "func", "prototype", "@1", "func_body", 
  "type_specifier", "direct_declarator", "emitted_variable", 
  "emitted_label", "even_specifier", "optional_identifier", "paramlist", 
  "parameters", "parameter", "varlist", "vardecl", "codeblock", 
  "expr_group", "complete_expr", "normal_expr", "root_expr", 
  "assign_expr", "bool_or_expr", "bool_and_expr", "or_expr", "xor_expr", 
  "and_expr", "comparison_expr", "inequality_expr", "shift_expr", 
  "additive_expr", "mult_expr", "prefix_expr", "suffix_expr", 
  "primary_expr", "function_call", "@2", "function_params", 
  "function_param", "conditional_expr", "simple_condition", "@3", 
  "else_condition", "@4", "return_statement", "do_while_loop", "@5", 
  "while_loop", "@6", "for_loop", "@7", "optional_expr", 
  "break_statement", "continue_statement", "struct_definition", "@8", 
  "struct_members", "struct_member", "@9", "member_array_specifiers", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,    33,   126,   299,   300,    42,    47,
      37,    43,    45,    60,    62,   301,    38,    94,   124,    61,
      59,   123,   125,    58,    40,    41,    44,    91,    93,    46
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    70,    71,    71,    72,    72,    72,    72,    72,    73,
      73,    73,    75,    74,    76,    76,    76,    77,    77,    78,
      78,    79,    79,    79,    79,    80,    80,    80,    81,    82,
      82,    83,    84,    84,    84,    85,    86,    86,    87,    87,
      87,    88,    88,    88,    89,    89,    90,    90,    90,    90,
      90,    90,    90,    90,    91,    92,    92,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    94,
      94,    95,    95,    96,    96,    97,    97,    98,    98,    99,
      99,    99,   100,   100,   100,   100,   100,   101,   101,   101,
     102,   102,   102,   103,   103,   103,   103,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   105,   105,   105,   105,
     105,   105,   105,   106,   106,   106,   106,   108,   107,   109,
     109,   109,   110,   111,   111,   113,   112,   115,   114,   116,
     118,   117,   120,   119,   122,   121,   123,   123,   124,   124,
     125,   125,   127,   126,   128,   128,   130,   129,   131,   131,
     131,   131
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     2,
       2,     5,     0,     4,     3,     3,     4,     1,     2,     1,
       2,     4,     4,     4,     4,     3,     6,     8,     2,     0,
       1,     3,     0,     1,     3,     2,     3,     2,     2,     5,
       4,     2,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     3,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     2,     2,
       4,     3,     3,     1,     1,     3,     1,     0,     5,     0,
       1,     3,     1,     1,     1,     0,     6,     0,     4,     3,
       0,     8,     0,     6,     0,    10,     0,     1,     2,     5,
       2,     5,     0,     7,     1,     2,     0,     5,     0,     3,
       6,     9
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,    19,     0,     0,     0,     0,     0,     0,
       3,     4,     0,     0,    17,     6,     7,     8,     5,     0,
      19,     0,     0,    20,     0,     0,     0,    28,     9,     0,
      10,    12,    18,   113,   114,   116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    55,    57,    69,    71,
      73,    75,    77,    79,    82,    87,    90,    93,    97,   106,
     107,    20,     0,     0,     0,    25,     0,     0,     0,     0,
       0,   130,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,     0,    47,   123,   124,    51,    48,    49,    50,
      52,    53,     0,     0,   100,   101,    98,    99,   104,   102,
     103,   105,     0,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   108,   109,     0,     0,     0,     0,
       0,    22,     0,    23,    24,     0,     0,     0,     0,   136,
     138,     0,   140,     0,    38,    14,     0,     0,    37,    15,
      44,    54,   127,    32,    13,   119,   115,    56,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    58,    70,
      72,    74,    76,    78,    80,    81,    84,    86,    83,    85,
      88,    89,    91,    92,    94,    95,    96,   112,     0,   111,
      11,     0,     0,   144,     0,     0,     0,   129,     0,     0,
      43,     0,   137,     0,     0,     0,     0,     0,    36,    16,
       0,    29,     0,    33,   122,     0,   120,   110,   146,     0,
     145,    26,     0,   125,    41,     0,     0,   132,   136,     0,
       0,    40,     0,   128,    30,    35,    31,     0,   118,     0,
     148,   143,     0,     0,    42,     0,     0,     0,   139,   141,
      39,    34,   121,     0,     0,    27,   126,     0,   133,   136,
       0,   147,     0,     0,   149,   131,   134,     0,     0,     0,
     135,   150,     0,     0,   151
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,    10,    11,    12,    92,    30,    13,    14,    15,
      16,    17,   245,   164,   222,   223,    77,    78,   209,    79,
     210,    81,    82,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    93,   225,
     226,    83,    84,   253,    85,   220,    86,    87,   147,    88,
     256,    89,   278,   213,    90,    91,    18,    63,   202,   203,
     250,   264
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -172
static const short yypact[] =
{
    -172,   102,  -172,   -48,     5,    73,    31,   105,    51,    59,
    -172,  -172,   -33,    45,  -172,  -172,  -172,  -172,  -172,   429,
    -172,   121,    74,    86,   146,   -52,    18,  -172,  -172,   117,
    -172,  -172,  -172,    99,  -172,  -172,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   -59,    16,   151,   161,   112,
     123,   126,   113,   118,   147,   127,    55,  -172,    10,  -172,
    -172,  -172,   183,   131,   137,  -172,   429,   139,   149,   152,
     429,  -172,   174,   177,   -40,   -38,    80,    36,   182,   181,
    -172,  -172,   -55,  -172,   200,  -172,  -172,  -172,  -172,  -172,
    -172,  -172,   190,   191,  -172,  -172,  -172,  -172,  -172,  -172,
    -172,  -172,   128,  -172,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,  -172,  -172,   244,   429,   253,   197,
       5,  -172,   308,  -172,  -172,   429,   -50,   243,   429,   429,
    -172,   254,  -172,   255,   -53,  -172,   201,   300,  -172,  -172,
    -172,  -172,  -172,     5,  -172,   429,  -172,    16,    16,    16,
      16,    16,    16,    16,    16,    16,    16,    16,    16,  -172,
    -172,  -172,  -172,  -172,  -172,  -172,  -172,  -172,  -172,  -172,
    -172,  -172,  -172,  -172,  -172,  -172,  -172,  -172,    23,  -172,
    -172,    83,     9,  -172,   202,   429,   362,  -172,   360,   231,
    -172,   130,   199,   206,   203,   204,   429,   429,  -172,  -172,
     243,    87,   156,  -172,    16,   158,  -172,  -172,  -172,   207,
    -172,  -172,   427,  -172,  -172,   420,   208,  -172,   429,   210,
     211,    16,    29,  -172,  -172,  -172,  -172,     5,  -172,   429,
     214,  -172,   213,   243,  -172,   429,   243,   218,  -172,  -172,
    -172,  -172,  -172,   429,   222,  -172,  -172,   162,  -172,   429,
      33,  -172,   223,   219,   225,  -172,  -172,   429,   243,    49,
    -172,   226,   429,    98,  -172
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -172,  -172,  -172,  -172,   281,  -172,  -172,   -27,  -172,  -172,
    -172,  -172,  -172,  -172,  -172,    39,  -172,   212,  -171,   -74,
     -25,  -172,   -19,   -49,   180,   173,   179,   192,   178,   109,
      34,   107,   110,   -21,   165,  -172,  -172,  -172,  -172,  -172,
      52,  -172,  -172,  -172,  -172,  -172,  -172,  -172,  -172,  -172,
    -172,  -172,  -172,  -160,  -172,  -172,  -172,  -172,  -172,   100,
    -172,  -172
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -143
static const short yytable[] =
{
      45,   103,    76,   157,    80,   161,   216,   104,    65,    20,
     207,   104,    66,    20,   217,    19,   104,   142,   134,   135,
     150,    67,   152,    68,   151,   102,   153,    28,    29,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,    33,
      20,    34,    35,    21,    36,    37,    69,    21,    31,   243,
      76,   146,    80,   136,   160,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,    70,    71,    72,
      73,   229,    74,    75,    21,   115,    23,   137,   257,   138,
      38,    39,   266,   154,    40,   268,   228,    41,    42,   104,
     244,   227,    43,    32,    24,   104,   206,   260,   155,   104,
      44,   274,     2,   131,   132,   133,     3,   280,    25,   273,
     194,   195,   196,   201,    26,   104,   224,   281,   198,    27,
      33,    20,    34,    35,    61,    36,    37,    69,    32,   211,
     212,    32,   160,    62,   235,    32,   221,     4,   121,   122,
       5,     6,     7,     8,     9,   123,   124,  -142,    70,    71,
      72,    73,    64,    74,    75,    21,   232,   186,   187,   188,
     189,    38,    39,  -117,   104,    40,   284,   241,    41,    42,
     118,   125,   126,    43,   116,   201,   127,   128,   129,   130,
     119,    44,   120,    80,    33,   117,    34,    35,   139,    36,
      37,    69,   140,   166,   104,   237,   104,   141,   242,   143,
     224,    94,    95,    96,    97,    98,    99,   100,   101,   144,
     160,   162,    70,    71,    72,    73,   145,    74,    75,   212,
     221,   246,   247,   248,   249,    38,    39,   272,   104,    40,
     184,   185,    41,    42,   190,   191,   267,    43,   148,   192,
     193,   149,   158,   159,   270,    44,    33,   197,    34,    35,
     212,    36,    37,    69,   163,   165,   199,   200,   279,   214,
     215,   218,   231,   283,   236,   104,   238,   251,   239,   240,
     258,   259,   255,   265,    70,    71,    72,    73,   269,    74,
      75,   263,   271,   275,   276,    22,   261,    38,    39,   156,
     180,    40,   277,   282,    41,    42,   179,   181,   183,    43,
       0,   262,   230,    33,   208,    34,    35,    44,    36,    37,
      69,   182,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,    70,    71,    72,    73,     0,    74,    75,     0,     0,
       0,     0,     0,     0,    38,    39,     0,     0,    40,     0,
       0,    41,    42,     0,     0,     0,    43,     0,     0,     0,
       0,     0,   219,    33,    44,    34,    35,   115,    36,    37,
      69,     0,     0,   204,   205,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,     0,     0,     0,     0,     0,
       0,    70,    71,    72,    73,     0,    74,    75,     0,     0,
       0,     0,     0,     0,    38,    39,     0,     0,    40,     0,
       0,    41,    42,     0,     0,     0,    43,     0,     0,     0,
       0,   115,   234,    33,    44,    34,    35,   233,    36,    37,
      69,     0,    33,     0,    34,    35,     0,    36,    37,     0,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
       0,    70,    71,    72,    73,     0,    74,    75,     0,     0,
       0,     0,     0,     0,    38,    39,     0,     0,    40,     0,
       0,    41,    42,    38,    39,     0,    43,    40,     0,     0,
      41,    42,   254,     0,    44,    43,   115,     0,     0,     0,
       0,     0,   252,    44
};

static const short yycheck[] =
{
      19,    60,    29,    77,    29,    60,    59,    66,    60,     4,
      60,    66,    64,     4,    67,    63,    66,    66,     8,     9,
      60,     3,    60,     5,    64,    44,    64,    60,    61,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,     3,
       4,     5,     6,    38,     8,     9,    10,    38,     3,   220,
      77,    70,    77,    43,    79,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    31,    32,    33,
      34,    62,    36,    37,    38,    59,     3,    67,   238,    69,
      44,    45,   253,     3,    48,   256,     3,    51,    52,    66,
       3,    68,    56,    48,    63,    66,   145,    68,    62,    66,
      64,    68,     0,    48,    49,    50,     4,   278,     3,   269,
     131,   132,   133,   140,    63,    66,   165,    68,   137,    60,
       3,     4,     5,     6,     3,     8,     9,    10,    48,   148,
     149,    48,   157,    59,   208,    48,   163,    35,    25,    26,
      38,    39,    40,    41,    42,    27,    28,    61,    31,    32,
      33,    34,     6,    36,    37,    38,   205,   123,   124,   125,
     126,    44,    45,    64,    66,    48,    68,   216,    51,    52,
      58,    53,    54,    56,    23,   202,    29,    30,    51,    52,
      57,    64,    56,   208,     3,    24,     5,     6,     5,     8,
       9,    10,    61,    65,    66,    65,    66,    60,   217,    60,
     249,    36,    37,    38,    39,    40,    41,    42,    43,    60,
     235,    11,    31,    32,    33,    34,    64,    36,    37,   238,
     247,    65,    66,    65,    66,    44,    45,    65,    66,    48,
     121,   122,    51,    52,   127,   128,   255,    56,    64,   129,
     130,    64,    60,    62,   263,    64,     3,     3,     5,     6,
     269,     8,     9,    10,    64,    64,     3,    60,   277,     5,
       5,    60,    60,   282,    33,    66,    60,    60,    65,    65,
      60,    60,    64,    60,    31,    32,    33,    34,    60,    36,
      37,    67,    60,    60,    65,     4,   247,    44,    45,    77,
     117,    48,    67,    67,    51,    52,   116,   118,   120,    56,
      -1,   249,   202,     3,    61,     5,     6,    64,     8,     9,
      10,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    31,    32,    33,    34,    -1,    36,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,    -1,    -1,    48,    -1,
      -1,    51,    52,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    62,     3,    64,     5,     6,    59,     8,     9,
      10,    -1,    -1,    65,    66,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    32,    33,    34,    -1,    36,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,    -1,    -1,    48,    -1,
      -1,    51,    52,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    59,    62,     3,    64,     5,     6,    65,     8,     9,
      10,    -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      -1,    31,    32,    33,    34,    -1,    36,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,    -1,    -1,    48,    -1,
      -1,    51,    52,    44,    45,    -1,    56,    48,    -1,    -1,
      51,    52,    62,    -1,    64,    56,    59,    -1,    -1,    -1,
      -1,    -1,    65,    64
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    71,     0,     4,    35,    38,    39,    40,    41,    42,
      72,    73,    74,    77,    78,    79,    80,    81,   126,    63,
       4,    38,    74,     3,    63,     3,    63,    60,    60,    61,
      76,     3,    48,     3,     5,     6,     8,     9,    44,    45,
      48,    51,    52,    56,    64,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,     3,    59,   127,     6,    60,    64,     3,     5,    10,
      31,    32,    33,    34,    36,    37,    77,    86,    87,    89,
      90,    91,    92,   111,   112,   114,   116,   117,   119,   121,
     124,   125,    75,   108,   104,   104,   104,   104,   104,   104,
     104,   104,    92,    60,    66,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    59,    23,    24,    58,    57,
      56,    25,    26,    27,    28,    53,    54,    29,    30,    51,
      52,    48,    49,    50,     8,     9,    43,    67,    69,     5,
      61,    60,    93,    60,    60,    64,    92,   118,    64,    64,
      60,    64,    60,    64,     3,    62,    87,    89,    60,    62,
      90,    60,    11,    64,    83,    64,    65,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    94,
      95,    96,    97,    98,    99,    99,   100,   100,   100,   100,
     101,   101,   102,   102,   103,   103,   103,     3,    92,     3,
      60,    77,   128,   129,    65,    66,    93,    60,    61,    88,
      90,    92,    92,   123,     5,     5,    59,    67,    60,    62,
     115,    77,    84,    85,    93,   109,   110,    68,     3,    62,
     129,    60,    93,    65,    62,    89,    33,    65,    60,    65,
      65,    93,    92,    88,     3,    82,    65,    66,    65,    66,
     130,    60,    65,   113,    62,    64,   120,   123,    60,    60,
      68,    85,   110,    67,   131,    60,    88,    92,    88,    60,
      92,    60,    65,   123,    68,    60,    65,    67,   122,    92,
      88,    68,    67,    92,    68
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:
#line 72 "src/compile.y"
    { hir_finish_prototype(); }
    break;

  case 10:
#line 74 "src/compile.y"
    { hir_finish_func_body(); }
    break;

  case 11:
#line 76 "src/compile.y"
    { hir_finish_extern_func(yyvsp[-1].numeric); }
    break;

  case 12:
#line 81 "src/compile.y"
    { hir_start_func(yyvsp[-1].datatype, yyvsp[0].identifier); }
    break;

  case 18:
#line 95 "src/compile.y"
    { yyval.datatype=type_pointer_to(yyvsp[-1].datatype); }
    break;

  case 19:
#line 100 "src/compile.y"
    { yyval.datatype=yyvsp[0].datatype; }
    break;

  case 20:
#line 102 "src/compile.y"
    { yyval.datatype = type_struct_named(yyvsp[0].identifier); }
    break;

  case 21:
#line 107 "src/compile.y"
    { hir_emit_constant(yyvsp[-3].datatype, yyvsp[-1].subexpr); }
    break;

  case 22:
#line 109 "src/compile.y"
    { hir_emit_string(yyvsp[-1].string); }
    break;

  case 23:
#line 111 "src/compile.y"
    { hir_emit_link(yyvsp[-1].identifier); }
    break;

  case 24:
#line 113 "src/compile.y"
    { hir_emit_constant(type_base(type_short), 0);
		  hir_emit_constant(type_base(type_short), yyvsp[-1].numeric);
		}
    break;

  case 25:
#line 120 "src/compile.y"
    { hir_emit_label(yyvsp[-1].identifier, hir_load_immediate(0), -1); }
    break;

  case 26:
#line 122 "src/compile.y"
    { hir_emit_label(yyvsp[-4].identifier, yyvsp[-2].subexpr, -1); }
    break;

  case 27:
#line 124 "src/compile.y"
    { hir_emit_label(yyvsp[-6].identifier, yyvsp[-4].subexpr, yyvsp[-2].subexpr); }
    break;

  case 28:
#line 129 "src/compile.y"
    { lir_write_inst(LIR_EVEN); }
    break;

  case 29:
#line 134 "src/compile.y"
    { yyval.identifier = blank_identifier(); }
    break;

  case 30:
#line 136 "src/compile.y"
    { yyval.identifier = yyvsp[0].identifier; }
    break;

  case 35:
#line 153 "src/compile.y"
    { hir_add_variable(yyvsp[-1].datatype, yyvsp[0].identifier, 1); }
    break;

  case 38:
#line 164 "src/compile.y"
    { hir_add_variable(yyvsp[-1].datatype, yyvsp[0].identifier, 0); }
    break;

  case 39:
#line 166 "src/compile.y"
    {
		hir_add_variable(type_pointer_to(yyvsp[-4].datatype), yyvsp[-3].identifier, 0);
		hir_finish_expr(
			hir_binary_op(
				hir_load_variable(yyvsp[-3].identifier),
				hir_unary_op(
					hir_binary_op(
						yyvsp[-1].subexpr,
						hir_load_immediate(type_size(yyvsp[-4].datatype)),
						HIR_BINOP_MUL
					),
					HIR_UNARYOP_ALLOCA
				),
				HIR_BINOP_EQ
			)
		);
	  }
    break;

  case 40:
#line 184 "src/compile.y"
    {
		hir_add_variable(yyvsp[-3].datatype, yyvsp[-2].identifier, 0);
		hir_finish_expr(
			hir_binary_op(
				hir_load_variable(yyvsp[-2].identifier),
				yyvsp[0].subexpr,
				HIR_BINOP_EQ
			)
		);
	  }
    break;

  case 54:
#line 222 "src/compile.y"
    { hir_finish_expr(yyvsp[-1].subexpr); }
    break;

  case 55:
#line 226 "src/compile.y"
    { yyval.subexpr = yyvsp[0].subexpr;                                               }
    break;

  case 56:
#line 227 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_COMMA);  }
    break;

  case 57:
#line 231 "src/compile.y"
    { yyval.subexpr = yyvsp[0].subexpr;                                               }
    break;

  case 58:
#line 232 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_EQ);     }
    break;

  case 59:
#line 233 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_ADDEQ);  }
    break;

  case 60:
#line 234 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_SUBEQ);  }
    break;

  case 61:
#line 235 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_MULEQ);  }
    break;

  case 62:
#line 236 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_DIVEQ);  }
    break;

  case 63:
#line 237 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_MODEQ);  }
    break;

  case 64:
#line 238 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_ANDEQ);  }
    break;

  case 65:
#line 239 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_XOREQ);  }
    break;

  case 66:
#line 240 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_OREQ);   }
    break;

  case 67:
#line 241 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_LSFTEQ); }
    break;

  case 68:
#line 242 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_RSFTEQ); }
    break;

  case 70:
#line 247 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_OROR);   }
    break;

  case 72:
#line 252 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_ANDAND); }
    break;

  case 74:
#line 257 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_OR);     }
    break;

  case 76:
#line 262 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_XOR);    }
    break;

  case 78:
#line 267 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_AND);    }
    break;

  case 80:
#line 272 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_EQEQ);   }
    break;

  case 81:
#line 273 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_NEQ);    }
    break;

  case 83:
#line 278 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_LT);     }
    break;

  case 84:
#line 279 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_LTEQ);   }
    break;

  case 85:
#line 280 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_GT);     }
    break;

  case 86:
#line 281 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_GTEQ);   }
    break;

  case 88:
#line 286 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_LSHIFT); }
    break;

  case 89:
#line 287 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_RSHIFT); }
    break;

  case 91:
#line 292 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_ADD);    }
    break;

  case 92:
#line 293 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_SUB);    }
    break;

  case 94:
#line 298 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_MUL);    }
    break;

  case 95:
#line 299 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_DIV);    }
    break;

  case 96:
#line 300 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-2].subexpr, yyvsp[0].subexpr, HIR_BINOP_MOD);    }
    break;

  case 97:
#line 304 "src/compile.y"
    { yyval.subexpr = yyvsp[0].subexpr;                                               }
    break;

  case 98:
#line 305 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[0].subexpr, HIR_UNARYOP_BOOLNOT);            }
    break;

  case 99:
#line 306 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[0].subexpr, HIR_UNARYOP_BITNOT);             }
    break;

  case 100:
#line 307 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[0].subexpr, HIR_UNARYOP_PREINCR);            }
    break;

  case 101:
#line 308 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[0].subexpr, HIR_UNARYOP_PREDECR);            }
    break;

  case 102:
#line 309 "src/compile.y"
    { yyval.subexpr = yyvsp[0].subexpr;                                               }
    break;

  case 103:
#line 310 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[0].subexpr, HIR_UNARYOP_NEG);                }
    break;

  case 104:
#line 311 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[0].subexpr, HIR_UNARYOP_DEREF);              }
    break;

  case 105:
#line 312 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[0].subexpr, HIR_UNARYOP_ADDRESS);            }
    break;

  case 107:
#line 317 "src/compile.y"
    { yyval.subexpr = yyvsp[0].subexpr;                                               }
    break;

  case 108:
#line 318 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[-1].subexpr, HIR_UNARYOP_POSTINCR);           }
    break;

  case 109:
#line 319 "src/compile.y"
    { yyval.subexpr = hir_unary_op(yyvsp[-1].subexpr, HIR_UNARYOP_POSTDECR);           }
    break;

  case 110:
#line 320 "src/compile.y"
    { yyval.subexpr = hir_binary_op(yyvsp[-3].subexpr, yyvsp[-1].subexpr, HIR_BINOP_ARRAY);  }
    break;

  case 111:
#line 321 "src/compile.y"
    { yyval.subexpr = hir_selection_op(yyvsp[-2].subexpr, yyvsp[0].identifier, HIR_BINOP_DOT); }
    break;

  case 112:
#line 322 "src/compile.y"
    { yyval.subexpr = hir_selection_op(yyvsp[-2].subexpr, yyvsp[0].identifier, HIR_BINOP_ARROW); }
    break;

  case 113:
#line 326 "src/compile.y"
    { yyval.subexpr = hir_load_variable(yyvsp[0].identifier);                         }
    break;

  case 114:
#line 327 "src/compile.y"
    { yyval.subexpr = hir_load_immediate(yyvsp[0].numeric);                           }
    break;

  case 115:
#line 328 "src/compile.y"
    { yyval.subexpr = yyvsp[-1].subexpr;                                               }
    break;

  case 116:
#line 329 "src/compile.y"
    { yyval.subexpr = hir_load_string(yyvsp[0].string);                               }
    break;

  case 117:
#line 335 "src/compile.y"
    { hir_start_call(yyvsp[0].identifier); }
    break;

  case 118:
#line 337 "src/compile.y"
    { yyval.subexpr = hir_finish_call(); }
    break;

  case 122:
#line 348 "src/compile.y"
    { hir_finish_expr(yyvsp[0].subexpr); }
    break;

  case 123:
#line 355 "src/compile.y"
    { finish_if_block(); }
    break;

  case 124:
#line 357 "src/compile.y"
    { finish_if_block(); }
    break;

  case 125:
#line 362 "src/compile.y"
    { start_if_block(yyvsp[-1].subexpr); }
    break;

  case 127:
#line 369 "src/compile.y"
    { start_else_block(); }
    break;

  case 129:
#line 376 "src/compile.y"
    { hir_finish_expr(
			hir_unary_op(yyvsp[-1].subexpr, HIR_UNARYOP_RETURN)
		  ); }
    break;

  case 130:
#line 383 "src/compile.y"
    { start_do_while_block(); }
    break;

  case 131:
#line 385 "src/compile.y"
    { finish_do_while_block(yyvsp[-2].subexpr); }
    break;

  case 132:
#line 390 "src/compile.y"
    { start_while_block(yyvsp[-1].subexpr); }
    break;

  case 133:
#line 392 "src/compile.y"
    { finish_while_block(); }
    break;

  case 134:
#line 397 "src/compile.y"
    { start_for_block(yyvsp[-5].subexpr, yyvsp[-3].subexpr, yyvsp[-1].subexpr); }
    break;

  case 135:
#line 399 "src/compile.y"
    { finish_for_block(); }
    break;

  case 138:
#line 409 "src/compile.y"
    { hir_break(1); }
    break;

  case 139:
#line 411 "src/compile.y"
    { hir_break(yyvsp[-2].numeric); }
    break;

  case 140:
#line 416 "src/compile.y"
    { hir_continue(1); }
    break;

  case 141:
#line 418 "src/compile.y"
    { hir_continue(yyvsp[-2].numeric); }
    break;

  case 142:
#line 425 "src/compile.y"
    { hir_start_struct(yyvsp[0].identifier); }
    break;

  case 143:
#line 427 "src/compile.y"
    { hir_finish_struct(); }
    break;

  case 146:
#line 437 "src/compile.y"
    { hir_add_member(yyvsp[-1].datatype, yyvsp[0].identifier); }
    break;

  case 149:
#line 445 "src/compile.y"
    { hir_member_array( yyvsp[-1].subexpr ); }
    break;

  case 150:
#line 447 "src/compile.y"
    { hir_member_array( yyvsp[-1].subexpr );
		  hir_member_array( yyvsp[-4].subexpr ); }
    break;

  case 151:
#line 450 "src/compile.y"
    { hir_member_array( yyvsp[-1].subexpr );
		  hir_member_array( yyvsp[-4].subexpr );
		  hir_member_array( yyvsp[-7].subexpr ); }
    break;


    }

/* Line 991 of yacc.c.  */
#line 1924 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



